/*
*Copyright(c)2014, Jeffrey Lee
*Allrightsreserved.
*
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef OPCODESUBSET_H
#define OPCODESUBSET_H

#include "common.h"

class opcode_subset
{
public:
	opcode_subset();
	opcode_subset(const opcode_subset &copy);
	~opcode_subset();

	uint32_t fixed; /* Value of decoded bits */
	uint32_t mask; /* Mask of decoded bits */
	constraintset match; /* Constraints which have been matched */
	constraintset nomatch; /* Constraints which have been made to not match */

	void constrain(uint32_t f,uint32_t m); /* Constrain by fixed bits */
	void constrain(const constraint *c,bool shouldmatch); /* Constrain by encoding match */
	void constrain(const encodingset &e); /* Constrain by encoding set (adds any invariant bits to the fixed mask) */

	bool matches(uint32_t opcode) const; /* Checks fixed bits & match list */
	bool doesntmatch(uint32_t opcode) const; /* Just checks nomatch list */
};

#endif
